﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Persistence;

namespace doLogic
{
	public class Groups : PersistentList<Group>
	{
		private static Groups _Groups = null;
		public static Groups All
		{
			get
			{
				if (_Groups == null)
					_Groups = new Groups(true);
				return _Groups;
			}
		}

		internal static Groups ForUser(User user)
		{
			Groups list = new Groups(false);
			foreach (Group g in new Groups(user))
				list.Add(Groups.All.ItemById(g.ID));
			return list;
		}

		private Groups(User user)
		{
			this.UserID = user.ID;
			this.Load("ForUser");
		}

		private Groups(bool fill)
		{
			if (fill)
				this.Load();
		}

		public int UserID { get; set; }
	}

	[Persistable("secGroup", "ID", false)]
	public class Group
	{
		public string DisplayName
		{
			get
			{
				return String.Format("{0} ({1})", this.Name, this.ShortName);
			}
		}

		public int ID { get; set; }
		public string Name { get; set; }
		public bool IsInternal { get; set; }
		public string ShortName { get; set; }
	}
}
